/*********************************************************************
 *  SPDX-License-Identifier: MIT									 *
 *  Copyright (C) 2007-2024 by Helge Kortendieck  alan@kasmithee.de  *
 *                                                                   *
 *  This file is part of siimvi.                                     *
 *********************************************************************/
#ifndef _ABOUTHELP_H_
#define _ABOUTHELP_H_

#include <QDialog>
#include <QPoint>
#include <QWidget>

#include "ui_abouthelp.h"

class aboutHelp : public QDialog
{
	Q_OBJECT

public:
	aboutHelp(QDialog* parent = 0);
		~aboutHelp();

protected slots:
    /*$PROTECTED_SLOTS$*/
	void closeDlg();                    // close dialog

private:
	int iD;
	int iD2;
	int iTyp;					// dialog type: 1=About (html), 2=Help (html), 3=Error (txt)
	int iHeight;				// dialog height
	int iWidth;					// dialog width

	Ui::Help uih;				// help widget

	QDialog wHelp;				// help widget

	QPoint qPos;				// position to show about dialog

	QString sText;				// about/help/error text
	QString sTitle;				// dialog title

private slots:
	void setText();				// set text to show: 1=About (html), 2=Help (html), 3=Error (txt)
	void showAbout();			// show about dialog
	void showDlg();
	void showHelp();			// show help dialog
	void showMsg(const QString& sTitle, const QString& sText);	// show error dialog, with long program feedback

	signals:
		void sigAhwHidden();
};

#endif
