/*********************************************************************
 *  SPDX-License-Identifier: MIT									 *
 *  Copyright (C) 2008-2024 by Helge Kortendieck  alan@kasmithee.de  *
 *                                                                   *
 *  This file is part of siimvi.                                     *
 *********************************************************************/
#include "info.h"

InfoW::InfoW(QWidget* parent)	//, Qt::WindowFlags fl
	: QWidget(parent)	//, fl
{
	bEt = false;

	uii.setupUi(&wInfo);
	connect(uii.pB_Close, SIGNAL(clicked()), this, SLOT(dlgClose()));
	setRead();

	if (bSetFont == true) {
		QFont font;
		font.setPointSize(iFontSize);
		wInfo.setFont(font);
//    uii->setFont(font);
	}
/*
  iD = QX11Info::appScreen();                   // screen number this program is started
  iD2 = QApplication::desktop()->numScreens();  // number of available screens
  cout << "appScreen & numScreens: " << QString::number( iD ).toStdString() << " : " << QString::number( iD2 ).toStdString() << endl;                                               // *****  debug

// try setting widget to selected screen
  char *display_name = getenv("DISPLAY");  // address of the X display
  sD = display_name;
  cout << sD.toStdString() << endl;
  Display *display;
//  display = XOpenDisplay(display_name);  // connect to display
  display = XOpenDisplay( ":1.1" );  // connect to display
//  if (display == NULL) {
//     cout << "cannot connect to X server" << endl;
//  }
  Window win = winId();                   // work with this window
  Window rootwinid = DefaultRootWindow(display);  // root window receives these events
  Atom atoms[2];
  atoms[0] = XInternAtom (display, "_NET_WM_STATE_STICKY", False);
  atoms[1] = XInternAtom (display, "_NET_WM_STATE_SKIP_TASKBAR", False);

  XChangeProperty (display, win, XInternAtom (display,"_NET_WM_STATE",False),XA_ATOM,32,PropModeReplace, (unsigned char *) &atoms, 2);

  XCloseDisplay(display);
*/

/*
QDesktopWidget *desktop = QApplication::desktop();
    
int screenWidth, width; 
int screenHeight, height;
int x, y;
QSize windowSize;

iD = desktop->primaryScreen();
iD2 = desktop->numScreens();
  cout << QString::number( iD ).toStdString() << " : " << QString::number( iD2 ).toStdString() << endl;
screenWidth = desktop->width(); // get width of screen
screenHeight = desktop->height(); // get height of screen
 
windowSize = size(); // size of our application window
width = windowSize.width(); 
height = windowSize.height();
 
// little computations
x = (screenWidth - width) / 2;
y = (screenHeight - height) / 2;
y -= 50;
 
// move window to desired coordinates
move ( x, y );
*/



//  cout << "Exiv2 version number: " << iExiv2 << endl;                                               // *****  debug
//  connect( , SIGNAL( destroyed() ), this, SLOT( closeDlg() ) );
}

InfoW::~InfoW()
{
}

void InfoW::setRead()
{
	QSettings settings("siimvi", "siimvi");
	settings.beginGroup("main");
		posI = settings.value("infopos", QPoint(5, 5)).toPoint();
		sizeI = settings.value("infosize", QSize(330, 550)).toSize();
		bSetFont = settings.value("usediffinfofont", "false").toBool();   // use a different font size for info widget
		iFontSize = settings.value("infowidgetfontsize", 11).toInt();     // font size for info widget
	settings.endGroup();
}


void InfoW::setWrite()
{
	QSettings settings("siimvi", "siimvi");
	settings.beginGroup("main" );
		settings.setValue("infopos", wInfo.pos());
		settings.setValue("infosize", wInfo.size());
	settings.endGroup();
	settings.sync();
}


void InfoW::dlgShow()                       // show about dialog, type 1
{
//	wInfo.resize(sizeI);
	wInfo.move(posI);
	wInfo.adjustSize();
	wInfo.show();
}

void InfoW::dlgToFrt()                      // bring dialog back to front
{
	wInfo.hide();
	wInfo.show();
}

void InfoW::dlgClose()                      // close dialog
{
	if (wInfo.pos() != posI or wInfo.size() != sizeI) {
		posI = wInfo.pos();
		sizeI = wInfo.size();
		setWrite();
	}
	wInfo.hide();
	emit sigInfHidden();
}


void InfoW::iwUpd(const QString& sD, int iD, int iD2, int iD3, int iD4, int iD5)	// get info what image info to show
{
	sImCur = sD;
	iImOrigX = iD;
	iImOrigY = iD2;
	iImCurX = iD3;
	iImCurY = iD4;
	iRotate = iD5;
	iwClear();
	iwGet();
}

void InfoW::iwClear()						// clear image info widget entries
{
// main
	uii.l_SyName->clear();						// system information
	uii.l_SySize->clear();

	uii.l_ImType->clear();						// image information
	uii.l_ImDim->clear();
	uii.l_ImCurOrient->clear();
	uii.l_ImColor->clear();
	uii.l_ImEDT->clear();
	uii.l_ImExif->clear();

	uii.l_ExpoTime->clear();					// camera main settings
	uii.l_FNo->clear();
	uii.l_FocLen->clear();
	uii.l_ISO->clear();

	uii.l_WhiteBalance->clear();
	uii.l_Flash->clear();
	uii.l_ExpoProg->clear();
	uii.l_ExpoComp->clear();
	uii.l_MeterMode->clear();
	uii.l_FocusMode->clear();
	uii.l_AfMode->clear();

	uii.l_CamMakeModel->clear();				// camera and lens main information
	uii.l_LensMakeModel->clear();
	uii.l_LensFocLen->clear();
	uii.cB_AF->setChecked( false );
	uii.cB_LS->setChecked( false );

// more
	uii.l_DyRaEn->clear();						// more camera and other settings
	uii.l_HighISONr->clear();
	uii.l_LongExpoNr->clear();
	uii.l_Crop->clear();

	uii.l_PpsImQuality->clear();
	uii.l_PicMode->clear();						// camera post processing settings
	uii.l_EasyMode->clear();
	uii.l_Contrast->clear();
	uii.l_Saturation->clear();
	uii.l_Sharpness->clear();
	uii.l_GainCtrl->clear();

	uii.l_FlashMode->clear();					// flash details
	uii.l_FlashRedEye->clear();
	uii.l_FlashReturn->clear();
	uii.l_FlashDetails->clear();

	uii.l_MacroMode->clear();
	uii.l_DriveMode->clear();
	uii.l_FocusContinuous->clear();
	uii.l_SpotMeterMode->clear();

	uii.l_DigiZoomRate->clear();
	uii.l_MirLocUp->clear();
	uii.l_ShuCurSyn->clear();
	uii.l_Selftimer->clear();
	uii.l_AEB->clear();
	uii.l_AEBSeq->clear();
	uii.l_AEBShotNum->clear();

// ID
	uii.l_CamModelID->clear();					// additional camera n lens information
	uii.l_CamFirmware->clear();
	uii.l_CamSerial->clear();
	uii.l_CamExifVer->clear();
	uii.l_LensSerial->clear();

	uii.l_Owner->clear();						// authors information
	uii.l_Copyright->clear();
	uii.l_Comment->clear();
	uii.l_Desc->clear();
	uii.l_Author->clear();
}

void InfoW::iwGet()							// get image information
{
	QFileInfo qfi(sImCur);
	if (qfi.exists() == true) {
		uii.l_SyName->setText(sImCur);			// image name on disk
		iD = qfi.size();						// size in byte
		dD = iD / 1000;							// size in kbyte
		if (dD < 1000) {
			uii.l_SySize->setText(QString("%1 kB").arg(dD, 0, 'f', 0));
		} else {
			uii.l_SySize->setText(QString("%1 MB").arg(dD/1000 , 0, 'f', 2));
		}

		iD = sImCur.lastIndexOf(".");			// image type, currently lame, just the file ending
		if (iD > 0) {
			sD = sImCur;
			uii.l_ImType->setText(sD.remove(0, iD + 1));
		}

		sD = QString::number(iImOrigX) + " x " + QString::number(iImOrigY) + "  at  " + QString::number(iImCurX) + " x " + QString::number(iImCurY);
		uii.l_ImDim->setText(sD);				// image dimension, original and currently shown

		sD2 = "";
		switch (iRotate) {
			case 0:
				sD2 = tr("original");
				break;
			case 1:
				sD2 = tr("rotated 90° right");
				break;
			case 2:
				sD2 = tr("rotated 180°");
				break;
			case 3:
				sD2 = tr("rotated 90° left");
				break;
		}
		uii.l_ImCurOrient->setText(sD2);		// orientation of shown image

		uii.l_ImExif->setText(eiE.exifInfo);	// set if exif info found
		if (bEt == false) {
			iwExifEtCreate();					// create infoExif object
		}
		iwExifGet();
	}
}


// ***********************************************************
// **  exif handling: check, query, show status/error       **
// ***********************************************************
void InfoW::iwExifEtCreate()				// create infoExif object
{
	et = new Exiftool();
	connect( this, SIGNAL( sigGetExif( const QString& ) ), et, SLOT( procPrep( const QString& ) ) );
	connect( et, SIGNAL( sigEtDone( const ExifInf& ) ), this, SLOT( iwExifGot( const ExifInf& ) ) );
	bEt = true;
}

void InfoW::iwExifGet()						// get exif info of image
{
	emit sigGetExif( sImCur );
}

void InfoW::iwExifGot( const ExifInf& eiD )	// received exif info from infoexif
{
	eiE = eiD;
	iwExifPop();
}

void InfoW::iwExifPop()						// populate image info widget with exif information, then show
{
//  *****
//  *****  main info widget  *****
//  *****
//	uii.l_SyName->setText( sImCur );				// already set in iwGet()
//	uii.l_SySize->setText( ... );					// already set in iwGet()

//	uii.l_ImType->setText( ... );					// already set in iwGet()
//	uii.l_ImDim->setText( sD );						// already set in iwGet()
//	uii.l_ImCurOrient->setText( sD2 );				// already set in iwGet()
	uii.l_ImType->setText( eiE.type );				// image type
	uii.l_ImColor->setText( eiE.colorSpace + ", " + eiE.colorBits + " x " + eiE.colorComp + " bit" );		// color info
	uii.l_ImEDT->setText( eiE.dateTime );			// date and time
	uii.l_ImEDT->setToolTip( eiE.dateTimeOrig  );	// original date and time as tooltip
//	uii.l_ImExif->setText( eiE.exifInfo );			// already set in iwGet()

	uii.l_ExpoTime->setText( eiE.expoTime );		// exposure time, shutter speed
	uii.l_FNo->setText( eiE.aperture );				// aperture, f-No
	uii.l_FocLen->setText( eiE.focalLen );			// focal length
	uii.l_ISO->setText( eiE.ISO );					// ISO setting

	uii.l_WhiteBalance->setText( eiE.wb );			// white balance
	uii.l_Flash->setText( eiE.flash );				// flash: fired or not
	uii.l_ExpoProg->setText( eiE.expoProg );		// exposure program: auto, P, Av, Tv, A-dep, easy mode
	uii.l_ExpoComp->setText( eiE.expoComp );		// exposure compensation
	uii.l_MeterMode->setText( eiE.meterMode );		// metering mode: spot, evaluative, ctr wgtd avr
	uii.l_FocusMode->setText( eiE.focusMode );		// focus mode: one shot, AI servo, AI Focus
	uii.l_AfMode->setText( eiE.AFMode );			// auto focus mode

	uii.l_CamMakeModel->setText( eiE.make + ", " + eiE.model );			// camera make and model
	uii.l_LensMakeModel->setText( eiE.lensMake + " " + eiE.lensModel );	// lens make and model
	uii.l_LensFocLen->setText( eiE.lensFocalLen );						// lens focal range
//	uii.cB_AF->setChecked( eiE.lensFocalLen );		// auto focus enabled on lens
//	uii.cB_LS->setChecked( eiE.imgStabi );			// image stabilization enabled on lens


//  *****
//  *****  more info widget  *****
//  *****
	uii.l_DyRaEn->setText( eiE.dynRanEnh );			// dynamic range enhancement, highlight tone priority
	uii.l_HighISONr->setText( eiE.nrHighISO );		// high ISO noise reduction
	uii.l_LongExpoNr->setText( eiE.nrLongExpo );	// long exposure noise reduction
	uii.l_Crop->setText( eiE.crop );				// sensor crop factor

	uii.l_PpsImQuality->setText( eiE.imgQuality + " / " + eiE.imgSize );	// image quality and size from vendor
	uii.l_PicMode->setText( eiE.picMode );			// scene capture mode
	uii.l_EasyMode->setText( eiE.easyMode );		// easy mode details
	uii.l_Contrast->setText( eiE.contrast );		// contrast
	uii.l_Saturation->setText( eiE.saturation );	// saturation
	uii.l_Sharpness->setText( eiE.sharpness );		// sharpness
	uii.l_GainCtrl->setText( eiE.gain );			// gain control ?

	uii.l_FlashMode->setText( eiE.flashMode );		// flash mode
	uii.l_FlashRedEye->setText( eiE.flashRedEye );	// flash red eye
	uii.l_FlashReturn->setText( eiE.flashReturn );	// flash strobe return
	uii.l_FlashDetails->setText( eiE.flashDetails );// flash details

	uii.l_MacroMode->setText( eiE.macroMode );		// macro mode
	uii.l_DriveMode->setText( eiE.driveMode );		// drive mode
//	uii.l_FocusContinous->setText( eiE.xxx );		// focus continous
	uii.l_SpotMeterMode->setText( eiE.spotMode );	// spot metering mode
	uii.l_DigiZoomRate->setText( eiE.digiZoom );	// digital zoom factor
	uii.l_MirLocUp->setText( eiE.mirrorLockup );	// mirror lockup
	uii.l_ShuCurSyn->setText( eiE.shutCurtSync );	// shutter curtain sync
	uii.l_Selftimer->setText( eiE.selftimer );		// selftimer
	uii.l_AEB->setText( eiE.AEB );					// auto exposure bracketing
	uii.l_AEBSeq->setText( eiE.AEBSequence );		// exposure compensation = AEB base (center) value
	uii.l_AEBShotNum->setText( eiE.AEBShotNum );	// auto exposure bracketing value


//  *****
//  *****  ID info widget  *****
//  *****
	uii.l_CamModelID->setText( eiE.modelID );		// camera model ID
	uii.l_CamFirmware->setText( eiE.fw );			// camera firmware
	uii.l_CamSerial->setText( eiE.serial );			// camera serial
	uii.l_CamExifVer->setText( eiE.exifVer );		// camera exif version
	uii.l_LensSerial->setText( eiE.lensSerial );	// lens serial number

	uii.l_Owner->setText( eiE.owner );				// camera owner
	uii.l_Author->setText( eiE.author );			// author
	uii.l_Copyright->setText( eiE.copyright );		// image copyright notice
	uii.l_Comment->setText( eiE.comment );			// image user comment
	uii.l_Desc->setText( eiE.description );			// image description


	dlgShow();
}

void InfoW::iwExifErr()						// Exiv2 error
{
//  cout << "InfoW::err(): " << " reached ! " << endl;                                               // *****  debug  *****
	eiE.exifInfo = tr( "Exif error !" );
//  uii.l_ImExif->setToolTip( tr( "Exif seems to be installed, but error(s) occurred reading the image Exif information." ) );
}

void InfoW::convDouble()					// found '/',  assume x/y: turn this calculation into double and back in qstring sD to show in widget
{
	sD2 = sD.left(iD);
	sD3 = sD.right(sD.length() - iD - 1);
	dD = sD2.toDouble();
	dD2 = sD3.toDouble();
	if (dD > 0 and dD2 > 0) {					// only change sD if calculation OK, else original received string is displayed
		dD = dD / dD2;
		sD = QString("%1").arg(dD , 0, 'f', 1);
	}
}


// ***********************************************************
// **  event handling                                       **
// ***********************************************************
void InfoW::closeEvent(QCloseEvent *cev)    // key press event
{
//  cout << "closeEvent(): " << "a test" << endl;                                               // *****  debug  *****
  dlgClose();
}

void InfoW::hideEvent(QHideEvent *hev)    // key press event
{
  dlgClose();
}

void InfoW::keyPressEvent(QKeyEvent *kev)    // key press event
{
//  cout << "keyEvent(): " << "a test" << endl;                                               // *****  debug  *****
  switch (kev->key()) {
    case Qt::Key_I:
      dlgClose();
      break;
    case Qt::Key_Escape:
      dlgClose();
      break;
  }
}

void InfoW::mousePressEvent(QMouseEvent *mei)	// mouse event
{
  switch (mei->button()) {
    case Qt::MiddleButton:                		// close info widget
//  cout << "mousePressEvent(): " << "a test" << endl;                                               // *****  debug  *****
      dlgClose();
      break;
  }
}


//#include "info.moc"
