/*********************************************************************
 *  SPDX-License-Identifier: MIT									 *
 *  Copyright (C) 2007-2024 by Helge Kortendieck  alan@kasmithee.de  *
 *                                                                   *
 *  This file is part of siimvi.                                     *
 *********************************************************************/
#ifndef _SETTINGS_H_
#define _SETTINGS_H_

#include <QCheckBox>
#include <QDialog>
#include <QFont>
#include <QPoint>
#include <QSettings>
#include <QSize>
#include <QWidget>

#include "ui_settings.h"


class setDlg : public QDialog
{
	Q_OBJECT

public:
	setDlg(QDialog* parent = 0);
		~setDlg();

private:
	bool bsD;				// shall main program re-read it settings, any changes?

	QPoint pos;				// dialog position, top left corner

	QSize size;				// dialog size

	Ui::Settings uis;		// settings widget

	QDialog wSetDlg;		// settings widget

private slots:
	void setRead();			// read settings
	void setWrite();		// write settings
	void setWriteCancel();	// write settings, widget pos and size
	void dlgEnableSave();	// enable save button
	void dlgClose();		// close dialog
	void dlgSave();			// save settings

	signals:
		void sigReReadSet(bool);	// signal main program to re-read settings, bool whether re-read settings
};

#endif
