/***************************************************************************
 *   Copyright (C) 2007-2009 by Helge Kortendieck  alan@kasmithee.de       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#ifndef _TT_H_
#define _TT_H_

#include <QFont>
#include <QFont>
#include <QLabel>
#include <QPoint>
#include <QRect>
#include <QSettings>
#include <QSize>
#include <QString>
#include <QTimer>
#include <QWidget>


class tT : public QWidget
{
    Q_OBJECT

public:
  tT(QWidget* parent = 0, Qt::WindowFlags fl = Qt::X11BypassWindowManagerHint | Qt::FramelessWindowHint | Qt::WindowStaysOnTopHint );  // Qt::SplashScreen | 
    ~tT();

    /*$PUBLIC_FUNCTIONS$*/

public slots:
    /*$PUBLIC_SLOTS$*/

private:
  bool bShow;           // tooltip shown

  int iTime;            // time (seconds) name and size are shown
  int iFont;            // font size for name and/or size tooltip
  int iScrX;            // screen width
  int iScrY;            // screen height

  QFont font;           // font, used to set point size

  QLabel *l_Tt;         // tooltip

  QPoint pos;           // tooltip position, top left corner

  QSize qsFrame;        // tooltip dimension for name and/or size

  QString sTt;          // tooltip text

  QTimer *timerNS;      // timer to show name and/or size
  QTimer *timerTt;      // timer to tooltip at begin/end of image list

private slots:
  void setRead();       // read settings
  void tClose();        // close dialog
  void tShow( QPoint pos, const QString& sTt );                            // show tooltip at position pos with text sTt
  void tShowNS( int iScrX, int iScrY, const QString& sTt ); // show name and/or size at position pos with text sTt for iTime seconds
};

#endif
